import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0

Page {
	id: detailPage
	
	function setData(t) {
		name.text =  t['name'];
		sizeWhenDone.text = t['sizeWhenDone'];
		hashString.text = t['hashString'];
		isPrivate.text = t['isPrivate'];
		comment.text = t['comment'];
		peersConnected.text = t['peersConnected'];
		creator.text = t['creator'];
		peersSendingToUs.text = t['peersSendingToUs'];
		downloadedEver.text = t['downloadedEver'];
		uploadedEver.text = t['uploadedEver'];
		var tmp = "";
		for(var i=0;i<t['trackers'].length;i++) {
			tmp = tmp + "\n" + (t['trackers'][i]['announce']);
		}; 
		trackers.text = tmp;
		tmp = "";
		for(var i=0;i<t['peers'].length;i++) {
			tmp = tmp + "\n" + (t['peers'][i]['address']) + " ("+(t['peers'][i]['clientName']) + ")" ;
		};
		peersList.text = tmp;
		tmp = "";
		for(var i=0;i<t['files'].length;i++) {
			tmp = tmp + "\n" + (t['files'][i]) ;
		};
		fileList.text = tmp;
	}
	
	tools: ToolBarLayout {
        visible: true
 
		
        ToolIcon {
			id: toolIcon
			platformIconId: "toolbar-back";
            onClicked: {
				appWindow.pageStack.pop()
            }
		}

		ButtonRow {

          anchors {left: toolIcon.right; right: parent.right}

            

            platformStyle: TabButtonStyle { }
            
         TabButton { 
			tab: tab1
            iconSource: "file://opt/transmissionr/web/style/transmission/images/inspector-info2.png"
		}
			 TabButton { 
			 tab: tab2; 
			 iconSource: "file://opt/transmissionr/web/style/transmission/images/inspector-trackers2"+ (theme.inverted ? "-invert" : "")+".png"

			  }
         TabButton { tab: tab3; iconSource: "file://opt/transmissionr/web/style/transmission/images/inspector-peers2.png"}
         TabButton { tab: tab4; iconSource: "file://opt/transmissionr/web/style/transmission/images/inspector-files2.png"}

     }		
		/*
        ToolIcon {
			platformIconId: "toolbar-mediacontrol-play" + (theme.inverted ? "-inverse" : "");
            onClicked: {
				server.resumeTorrent(hashString.text);
            }
		}
        ToolIcon {
			platformIconId: "toolbar-mediacontrol-pause" + (theme.inverted ? "-inverse" : "");
            onClicked: {
				server.pauseTorrent(hashString.text);
            }
		}		
		        
        ToolIcon {
			platformIconId: "toolbar-delete"+ (theme.inverted ? "-inverse" : "");
            onClicked: {
				confirmDelete.open()
            }
		}
		*/
    }


QueryDialog {  
        id: confirmDelete   
        titleText: "Confirm"  
        message: "Do you want to delete the data of the torrent?"  
        acceptButtonText: "Yes, torrent and data"  
        rejectButtonText: "No, only torrent"  
        onAccepted: {server.deleteTorrent(hashString.text, true); appWindow.pageStack.pop();}
        onRejected: {server.deleteTorrent(hashString.text, false); appWindow.pageStack.pop(); }
    }
		
	

TabGroup {  
         id: tabgroup  
         currentTab: tab1  
         Page {
			id: tab2
		Flickable {
			id: settingsFlickable2
			anchors.fill: parent
            clip: true
			interactive: true
			contentWidth: parent.width
			contentHeight: settingsColumn2.height + 30

			Column {
				id: settingsColumn2
				spacing: 10
				width: parent.width - 40
				anchors.horizontalCenter: parent.horizontalCenter
				anchors.top: parent.top
				anchors.topMargin: 20
			
			GroupSeparator {
                title: qsTr("Trackers")
            }
            Label {
				id: trackers
				width: parent.width
  
            
             } 
             
             }
             }
         }
         Page {
			id: tab3
			
			Flickable {
			id: settingsFlickable3
			anchors.fill: parent
            clip: true
			interactive: true
			contentWidth: parent.width
			contentHeight: settingsColumn3.height + 30

			Column {
				id: settingsColumn3
				spacing: 10
				width: parent.width - 40
				anchors.horizontalCenter: parent.horizontalCenter
				anchors.top: parent.top
				anchors.topMargin: 20
			
			GroupSeparator {
                title: qsTr("Peers connected")
            }
            Label {
				id: peersConnected
				width: parent.width
  
             }              

            GroupSeparator {
                title: qsTr("Peers sending")
            }
            Label {
				id: peersSendingToUs
				width: parent.width
  
             } 
            GroupSeparator {
                title: qsTr("Peers list")
            }
            Label {
				id: peersList
				width: parent.width
  
             }              
             }
             }
			
         }
         Page {
			id: tab4
			
			
			Flickable {
			id: settingsFlickable4
			anchors.fill: parent
            clip: true
			interactive: true
			contentWidth: parent.width
			contentHeight: settingsColumn4.height + 30

			Column {
				id: settingsColumn4
				spacing: 10
				width: parent.width - 40
				anchors.horizontalCenter: parent.horizontalCenter
				anchors.top: parent.top
				anchors.topMargin: 20
			
			GroupSeparator {
                title: qsTr("Files")
            }
            Label {
				id: fileList
				width: parent.width
  
             }              


             
             }
             }
         }
         Page { 
			id: tab1
			
			/*ButtonRow {
			    anchors.left: parent.left
			    anchors.right: parent.right
			    anchors.top: parent.top
			    anchors.topMargin: 10
			    anchors.leftMargin: 10
			    anchors.rightMargin: 10
			    anchors.bottomMargin: 10
			 
                id: rou
                exclusive: false
                Button { 
                iconSource: "image://theme/icon-m-toolbar-mediacontrol-play"+ (theme.inverted ? "-white" : "");
                onClicked:server.resumeTorrent(hashString.text); 
                 }
                Button { 
                iconSource: "image://theme/icon-m-toolbar-mediacontrol-pause" + (theme.inverted ? "-white" : "");
                onClicked: server.pauseTorrent(hashString.text);
                }
                Button { 
                iconSource: "image://theme/icon-m-toolbar-delete" + (theme.inverted ? "-white" : "");
                onClicked: confirmDelete.open()
                }
            }*/
            
		Flickable {
			id: settingsFlickable
			anchors.left: parent.left
			anchors.right: parent.right
			anchors.top: parent.top
			anchors.bottom: parent.bottom
            clip: true
			interactive: true
			contentWidth: parent.width
			contentHeight: settingsColumn.height + 30

			Column {
				
				id: settingsColumn
				spacing: 10
				width: parent.width - 40
				anchors.horizontalCenter: parent.horizontalCenter
				anchors.top: parent.top
				anchors.topMargin: 20

				GroupSeparator {
					title: qsTr("Name")
				}
				Label {
					id: name
					width: parent.width
				}
				GroupSeparator {
					title: qsTr("Size")
				}   
				Label {
					id: sizeWhenDone
					width: parent.width
	  
				 }  
				
				GroupSeparator {
					title: qsTr("Hash string")
				}   
				Label {
					id: hashString
					width: parent.width
	  
				 }   
				GroupSeparator {
					title: qsTr("Creator")
				}
				Label {
					id: creator
					width: parent.width
	  
				 }  
				GroupSeparator {
					title: qsTr("Private")
				}
				Label {
					id: isPrivate
					width: parent.width
	  
				 }        
				 
             GroupSeparator {
                title: qsTr("Comment")
            }
            Label {
				id: comment
				width: parent.width
  
             }        

    

            GroupSeparator {
                title: qsTr("Uploaded")
            }
            Label {
				id: uploadedEver
				width: parent.width
  
             }  
             
            GroupSeparator {
                title: qsTr("Downloaded")
            }
            Label {
				id: downloadedEver
				width: parent.width
  
             }  
                     }
        
        
    }

    ScrollDecorator {
        flickableItem: settingsFlickable
    }
    }
	}
}
