import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0

Page {

    id: settingsPage
    
    function setUI(i) {
    
		closeDaemonSwitch.checked = i['closeonexit']
    }

    tools: ToolBarLayout {
        visible: true

        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: {
            server.setSettings(theme.inverted, closeDaemonSwitch.checked)
            appWindow.pageStack.pop()
            }
        }
        ToolIcon {
			platformIconId: "toolbar-view-menu";
            onClicked: (myMenu.status == DialogStatus.Closed) ? myMenu.open() : myMenu.close()
		}
    }

    Flickable {
        id: settingsFlickable
        anchors.fill: parent

        interactive: true
        contentWidth: parent.width
        contentHeight: settingsColumn.height + 30
        clip: true

        Column {
            id: settingsColumn
            spacing: 10
            width: parent.width - 40
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: parent.top
            anchors.topMargin: 20

            GroupSeparator {
                title: qsTr("Appeareance")
            }
            Label {
                text: "Inverted theme"
                width: parent.width
                height: invertedThemeSwitch.height
                verticalAlignment: Text.AlignVCenter

                Switch {
                    id: invertedThemeSwitch
                    anchors.right: parent.right
                    checked: theme.inverted


                    Binding {
                        target: theme
                        property: "inverted"
                        value: invertedThemeSwitch.checked
                    }

                }
            }
             Label {
                text: "Close daemon on exit"
                width: parent.width
                height: closeDaemonSwitch.height
                verticalAlignment: Text.AlignVCenter

                Switch {
                    id: closeDaemonSwitch
                    anchors.right: parent.right
                    checked: false


                }
            }


        }
    }

    ScrollDecorator {
        flickableItem: settingsFlickable
    }

}
