import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0


Page {
	property bool bannerStart: false
property int selectedBeerNumber: -1

    function getSmallImage(imateStatus) {
		if (imateStatus == "upload")
			return "icon-m-toolbar-up";
		if (imateStatus == "download")
			return "icon-m-toolbar-down";
		if (imateStatus == "pause")
			return "icon-m-toolbar-mediacontrol-pause";
		
    }
    
    function getPorcentageAsText(total, parcial, ratio)
    {
        return (parcial + " of " + total + " (Ratio " + ratio + ")")
    }
    
    function hideSearchBar() {
		pythonList.forceActiveFocus()
        searchbar.h1 = 71
        searchbar.h2 = 0
        searchbar.height = 0
        searchInput.enabled = false
        sbutton.enabled = false
        searchInput.text = ""
        searchInput.focus = false
		
        timer.stop()
    }

    function showSearchBar() {
		if (searchInput.enabled == true) return;
        searchbar.h1 = 0
        searchbar.h2 = 71
        searchbar.height = 71
        searchInput.enabled = true
        sbutton.enabled = true
        searchInput.text = ""
        searchInput.focus = false
        pythonList.forceActiveFocus()
        timer.start()
    }
    
    QueryDialog {  
        id: confirmDelete   
        titleText: "Confirm"  
        message: "Do you want to delete the data of the torrent?"  
        acceptButtonText: "Yes, torrent and data"  
        rejectButtonText: "No, only torrent"  
        onAccepted: {server.deleteTorrent(selectedBeerNumber, true);}
        onRejected: {server.deleteTorrent(selectedBeerNumber, false);  }
    }
    
        
Menu {
        id: torrentDetailMenu
        visualParent: pageStack
        MenuLayout {

            MenuItem { 
				text: "Start" 
				onClicked: {
					 server.resumeTorrent(selectedBeerNumber);
				}				
            }
            
            MenuItem { 
				text: "Stop" 
				onClicked: {
					server.pauseTorrent(selectedBeerNumber);				
					}				
            }

            MenuItem { 
				text: "Delete" 
				onClicked: {
					confirmDelete.open()
				}				
            }
                                
            MenuItem { 
				text: "Details" 
				onClicked: {
					var tinfo = server.getTorrentInfo(selectedBeerNumber);
					detailPage.setData(tinfo);
					appWindow.pageStack.push(detailPage);
				}				
            }
            }
      }
    
Menu {
        id: torrentListMenu
        visualParent: pageStack
        MenuLayout {
            MenuItem { 
				text: "Show All" 
				onClicked: {
				torrentModel.showTorrents(0)
				}				
            }
            MenuItem { 
				text: "Show Active only" 
				onClicked: {
				torrentModel.showTorrents(1)
				}				
            }     
             MenuItem { 
				text: "Show Downloading" 
				onClicked: {
				torrentModel.showTorrents(2)
				}				
            }    
             MenuItem { 
				text: "Show Seeding" 
				onClicked: {
				torrentModel.showTorrents(3)
				}				
            }           
            
             MenuItem { 
				text: "Show Paused" 
				onClicked: {
				torrentModel.showTorrents(4)
				}				
            }                         

             MenuItem { 
				text: "Show Completed" 
				onClicked: {
				torrentModel.showTorrents(5)
				}	
			}
				
            MenuItem { 
				text: "Settings" 
				onClicked: {
				appWindow.pageStack.push(settingsPage);			
				}					
            }
        }
    }
    
    
        
    Timer {
        id: timer
        interval: 7000
        onTriggered: 
            if (searchInput.text==="") hideSearchBar()     
    }   
    
    id: torrentList
    tools: torrentTools
	ToolBarLayout {
        id: torrentTools
        visible: true

 
        ToolIcon {
			id: addTorrent
			platformIconId: "toolbar-add";
		//	iconSource : "file://opt/transmissionr/web/style/transmission/images/toolbar-folder.png"
            onClicked: {	
				torrentUrl.text = "";
				torrentUrl.paste();
				if (torrentUrl.text.substring(0, 7) != "magnet:" && torrentUrl.text.substring(0, 4) != "http" && torrentUrl.text.substring(0, 4) != "ftp:" )
					torrentUrl.text = "";
				sheet.open()
				torrentUrl.forceActiveFocus();
				
             }
		}
		
	
       ToolIcon {
       
			platformIconId: "toolbar-refresh";
            onClicked: 	{
				server.refresh();
            }

		}
				
		
		/* ToolIcon {
			
			id: deleteSelected
			platformIconId: "toolbar-delete";
			//iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-close.png"
			onClicked: {
				confirmDelete.open()
			 
			}
		} 
				
		ToolIcon {
		
			id: startSelected
			platformIconId: "toolbar-mediacontrol-play";
			//iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-start.png"
			onClicked: {
				if (selectedBeerNumber != -1)
				 server.resumeTorrent(selectedBeerNumber);
			 
			}
		}
		
		 ToolIcon {
			id: pauseSelected
			platformIconId: "toolbar-mediacontrol-pause";

			//iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-pause.png"
			onClicked: {
				if (selectedBeerNumber !=-1)
					 server.pauseTorrent(selectedBeerNumber);
			 
			}
		}*/

		 ToolIcon {
			iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-start-all.png"
			onClicked: {
				server.startAll();
			}
		}
		ToolIcon {
			iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-pause-all.png"
			onClicked: {
				server.pauseAll();			 
			}
		}
		/*
		 ToolIcon {
			iconSource: "file://opt/transmissionr/web/style/transmission/images/toolbar-info.png"
			onClicked: {
			 
			 		var tinfo = server.getTorrentInfo(selectedBeerNumber);
					detailPage.setData(tinfo);
					appWindow.pageStack.push(detailPage);
			}
		}
		 
		 ToolIcon {
			platformIconId: "toolbar-settings";
            onClicked:  {
				if (torrentListMenu.status != DialogStatus.Closed)  torrentListMenu.close()
				appWindow.pageStack.push(settingsPage);
			}
		}
*/
        ToolIcon {
			platformIconId: "toolbar-view-menu";
            onClicked:  (torrentListMenu.status == DialogStatus.Closed) ? torrentListMenu.open() : torrentListMenu.close()
		}		       

    }
    
    
 Rectangle {
	id: searchbar
	width: parent.width
	height: 0
	//anchors.top: header.bottom
	anchors.topMargin: 2
	color: "transparent"
	clip: true

	property int h1
	property int h2

	Rectangle {

	id: srect
	anchors.fill: searchbar
	anchors.leftMargin: 12
	anchors.rightMargin: 12
	anchors.top: searchbar.top
	anchors.topMargin: searchbar.height - 62
	anchors.bottomMargin: 2
	color: "transparent"

	TextField {
		id: searchInput
		inputMethodHints: Qt.ImhNoPredictiveText
		placeholderText: qsTr("Quick search")
		anchors.top: srect.top
		anchors.left: srect.left
		width: parent.width
		enabled: false
		onTextChanged: timer.restart()
	}

	Image {
		id: sbutton
		smooth: true
		anchors.top: srect.top
		anchors.topMargin: 1
		anchors.right: srect.right
		anchors.rightMargin: 4
		height: 52
		width: 52
		enabled: false
		source: searchInput.text==="" ? "image://theme/icon-m-common-search" : "image://theme/icon-m-input-clear"
		MouseArea {
			anchors.fill: parent
			onClicked: {
				searchInput.text = ""
				searchInput.forceActiveFocus()
			}
		}
	}

}

onHeightChanged: SequentialAnimation {
PropertyAction { target: searchbar; property: "height"; value: searchbar.h1 }
NumberAnimation { target: searchbar; property: "height"; to: searchbar.h2; duration: 300; easing.type: Easing.InOutQuad }
}

        states: [
            State {
                name: 'hidden'; when: searchbar.height == 0
                PropertyChanges { target: searchbar; opacity: 0; }
            },
            State {
                name: 'showed'; when: searchbar.height == 71
                PropertyChanges { target: searchbar; opacity: 1; }
            }
        ]
        transitions: Transition {
            NumberAnimation { properties: "opacity"; easing.type: Easing.InOutQuad; duration: 300 }
        }


}   


 FileSelector { 
		id: fileSelector; 
		filterList: ["*.torrent", "*.TORRENT"];
		onAccepted: {
				server.addTorrent(selectedFile); 
				sheet.close()
			}	
     }
  
 Sheet {
     id: sheet

     acceptButtonText: "Add"
     rejectButtonText: "Cancel"
     

		
     content: Flickable {
         anchors.fill: parent
         anchors.leftMargin: 10
         anchors.topMargin: 10

         flickableDirection: Flickable.VerticalFlick


     Column {
      
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: 10
        anchors.right: parent.right
		anchors.rightMargin: 10
		spacing: 20
		
        height: parent.height    

 
			Label {
				text: qsTr("Torrent/Magnet URI")
			    width: parent.width
			}
		

			TextField {
				id: torrentUrl
				text: qsTr("")
				font.pointSize: 20
				width: parent.width
			}
			
			Label {
				text: qsTr("Local File")
			    width: parent.width
			}
		
			
			Button {

				onClicked: fileSelector.open();
				text: qsTr("Select torrent file")
				width: parent.width
			}
									
			
			}


     }
     onAccepted: {
		server.addTorrent(torrentUrl.text)
     }
     
 }      
      
     
   /*Rectangle {
        id: header
        height: (screen.currentOrientation != Screen.Landscape)  ? 71 : 51
        color: "transparent"
        anchors { left: parent.left; top: parent.top; right: parent.right }
        //visible: (screen.currentOrientation != Screen.Landscape)    

        Image {
            width: header.width; height: header.height
            fillMode: Image.TileHorizontally
            smooth: true
            source: "image://theme/color9-meegotouch-view-header-fixed"
        }
        
        Text {
            x: 16
            width: parent.width - 20
            elide: Text.ElideRight
            font.pixelSize: 32
            color: "white"
            text: qsTr("Transmission Remote")
            anchors.verticalCenter: header.verticalCenter
        }

    }    
    */
    
 
     
    Rectangle {
        //anchors.top: header.bottom
        anchors.top: parent.top
		anchors.topMargin: searchbar.height
        width:parent.width
        height:parent.height - searchbar.height //- header.height
		color: "transparent"
		clip: true

    ListView {
        id: pythonList
        clip: true
        anchors.fill: parent
        visible: true
        model: torrentModel
       // Component.onCompleted: fast.listViewChanged()
        delegate: simpleDelegate 
        
        /*section.property: "title"
        section.criteria: ViewSection.FullString          
        section.delegate: Item {
                width: parent.width
                height: 40
                Text {
                    id: headerLabel
                    anchors.right: parent.right
                    anchors.bottom: parent.bottom
                    anchors.rightMargin: 8
                    anchors.bottomMargin: 2
                    text: section
                    font.bold: true
                    font.pointSize: 18
                    color: theme.inverted ? "#4D4D4D" : "#3C3C3C";
                }
                Image {
                    anchors.right: headerLabel.left
                    anchors.left: parent.left
                    anchors.verticalCenter: headerLabel.verticalCenter
                    anchors.rightMargin: 24
                    source: "image://theme/meegotouch-groupheader" + (theme.inverted ? "-inverted" : "") + "-background"
                }
            }
            
onContentYChanged: { if (bannerStart && (contentY <= -100)) showSearchBar(); }
onMovementStarted: { if (contentY==0) bannerStart = true; else bannerStart = false; }
onVerticalVelocityChanged: { if (verticalVelocity>0) bannerStart = false; }
onMovementEnded: { bannerStart = false; }              
 */
Component {
		id: simpleDelegate
        Rectangle {
			id: simpleDelegateRectangle
            width: pythonList.width
            height: UiConstants.ListItemHeightDefault
            color: theme.inverted ? ((index % 2 == 0)?"#222":"#111") : ((index % 2 == 0)?"#eee":"#ccc")
            Text {
                id: title
                elide: Text.ElideRight
                text: TORRENT_NAME
                color: theme.inverted ? "white" : "black"
                font.bold: true
                font.pointSize: 15
                anchors.leftMargin: 8
                anchors.rightMargin: 30
                //anchors.fill: parent
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.left: imgstatus.right
            }
            Image {
					  
				      source: "image://theme/" + getSmallImage(TORRENT_STATUS)+ (theme.inverted ? "-white" : "")
                      width: 40
                      height: 40
                      anchors.topMargin: 20
                      anchors.top: parent.top
                      anchors.left: parent.left
                      anchors.leftMargin: 12
                      id: imgstatus
             }
            Text {
                id: progress
                text:  TORRENT_PROGRESS +  "%" + " - " + getPorcentageAsText(TORRENT_SIZE, TORRENT_COMPLETED, TORRENT_RATIO)
                color: theme.inverted ? "white" : "black"
                font.bold: false
                font.pointSize: 14
                anchors.leftMargin: 8
                anchors.rightMargin: 30
                elide:Text.ElideRight
                anchors.top: title.bottom
                anchors.right: parent.right
                anchors.left: imgstatus.right
            }            
            MouseArea {
                anchors.fill: parent
                onPressed: { 
 
						selectedBeerNumber = TORRENT_ID;
						//deleteSelected.enabled = true;
						//pauseSelected.enabled = true;
						//startSelected.enabled = true;
			
					}
				onPressAndHold: {
					torrentDetailMenu.open()
				}
            }


             states: [
                State {
                    name: "selected"
                    when: (TORRENT_ID==selectedBeerNumber)
                    PropertyChanges {target: simpleDelegateRectangle; color: (theme.inverted ? "red" : "darkslateblue")}
                    PropertyChanges {target: title; color: "white"}
                    PropertyChanges {target: progress; color: "white"}
                    PropertyChanges {target: imgstatus; source: "image://theme/" + getSmallImage(TORRENT_STATUS)+  "-white" }
 

                }
            ]
        }

        
        
 }
           
                  
    
    }   
    
      ScrollDecorator {
     id: scrolldecorator
     flickableItem: pythonList
 }
  }
  
       
     
}
