import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0 

PageStackWindow {
    id: appWindow

    initialPage: mainPage
    
    showStatusBar: (screen.currentOrientation != Screen.Landscape)    

	InfoBanner { id: sb; topMargin: 60}
    MainPage {id: mainPage}
    TorrentList {id: torrentList}
    SettingsPage {id: settingsPage}
    DetailPage {id: detailPage}
    
    Timer {
		id: localConnect;
		repeat: false;
        interval: 2500;
        onTriggered: mainPage.connect("127.0.0.1", "9091", "", "");  
    }

	
    Menu {
        id: myMenu
        visualParent: pageStack
        MenuLayout {
        

            
            MenuItem { 
				text: "Start local daemon" 
				onClicked: {
						localConnect.start()
						server.startLocal();						
						mainPage.onServerConnecting();
						webui.visible = true
						
				}				
            }
            
            
        
        
            MenuItem { 
				text: "Stop local daemon" 
				onClicked: {
		
						server.stopLocal();
						webui.visible = false
					
				}				
            }
        
         MenuItem {
			visible: false
			id: webui
			text: "Open WebUI "
				onClicked:{
					Qt.openUrlExternally("http://localhost:9091/")
				}
            }
                       
                    
            MenuItem { 
				text: "About" 
				onClicked: {
					queryAbout.open()
				}				
            }
            
		}
    }
    
    
     QueryDialog {
          id: queryAbout
          icon: "file://opt/transmissionr/web/style/transmission/images/logo.png"
          titleText: qsTr("Transmission Remote")
          message: qsTr("© 2012\nLicensed under MIT")
          acceptButtonText: qsTr("Website")
          rejectButtonText: qsTr("Close")
          onAccepted: Qt.openUrlExternally("http://apps.beford.net/tranmissionr")
    }   
}
